/* stack routines */

#include "sb.h"
#include <stdio.h>

struct stack_entry stack[STACKSIZE];    /* the stack, statically allocated */
int sp = 0;                                /* the stack pointer */

void push(n,from)
/* pushes a node pointer and a direction onto the stack */
struct node *n;
char from;
{
    if (sp == STACKSIZE)
    {
        fprintf(stderr,"node stack overflow\n");
        exit(1);
    }

    stack[sp].p = n;
    stack[sp++].from = from;
}

struct node *pop()
/* pops the stack, returning the node pointer of the entry on
   top, or NULL if the stack is empty */
{
    return((sp == 0)? NULL : stack[--sp].p);
}

char fpeek()
/* returns the from field of the entry on top of the stack */
{
    return((sp>0)? stack[sp-1].from : NULL);
}

struct node *npeek()
/* returns the pointer field of the entry on top of the stack */
{
    return((sp>0)? stack[sp-1].p : NULL);
}
